
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 33 "./ctp_y.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mut.h"
#include "aut.h"
#include "vex.h"
#include "ctl.h"

#include "ctp_utype.h"
#include "ctp_bedef.h"
#include "ctp_bspec.h"
#include "ctp_byacc.h"

#if 1
# define my_fprintf fprintf( stdout, "%s.%d:", autbasename(__FILE__,NULL), __LINE__ ); fprintf
# define my_ctp_error(N,V) \
   do { fprintf( stderr, "%s.%d:", autbasename(__FILE__,NULL), __LINE__); ctp_error(N,V); } while(0)
#else
# define my_fprintf   fprintf
# define my_ctp_error ctp_error
#endif

#ifdef CTP_DEBUG
#define YYDEBUG 1
#endif



/* Line 189 of yacc.c  */
#line 103 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     _AF = 258,
     _AG = 259,
     _AX = 260,
     _AU = 261,
     _EF = 262,
     _EG = 263,
     _EX = 264,
     _EU = 265,
     Imply = 266,
     Equiv = 267,
     tok_AND = 268,
     _BEGIN = 269,
     _END = 270,
     _EQSym = 271,
     _EXIT = 272,
     _FILE = 273,
     _GESym = 274,
     _GTSym = 275,
     _IN = 276,
     _INOUT = 277,
     _LABEL = 278,
     _LESym = 279,
     _LINKAGE = 280,
     _LTSym = 281,
     _NAND = 282,
     _IFT = 283,
     _NXOR = 284,
     _NESym = 285,
     _NEXT = 286,
     _NOR = 287,
     _NOT = 288,
     _OR = 289,
     _OUT = 290,
     _XOR = 291,
     ABS = 292,
     ACCESS = 293,
     AFTER = 294,
     ALIAS = 295,
     ALL = 296,
     ARCHITECTURE = 297,
     ARRAY = 298,
     ASSERT = 299,
     ATTRIBUTE = 300,
     AbstractLit = 301,
     Ampersand = 302,
     Apostrophe = 303,
     Arrow = 304,
     BLOCK = 305,
     BODY = 306,
     BUS = 307,
     _BUFFER = 308,
     Bar = 309,
     BasedInt = 310,
     BasedReal = 311,
     BitStringLit = 312,
     _TRUE = 313,
     _FALSE = 314,
     Box = 315,
     CASE = 316,
     COMPONENT = 317,
     CONFIGURATION = 318,
     _DEFINE = 319,
     _ASSUME = 320,
     _INITIAL = 321,
     _RESET_COND = 322,
     CharacterLit = 323,
     Colon = 324,
     Comma = 325,
     DISCONNECT = 326,
     DOWNTO = 327,
     DecimalInt = 328,
     DecimalReal = 329,
     Dot = 330,
     DoubleStar = 331,
     ELSE = 332,
     ELSIF = 333,
     _ENTITY = 334,
     ERROR = 335,
     _EVENT = 336,
     _LEFT = 337,
     _LENGTH = 338,
     _RIGHT = 339,
     _HIGH = 340,
     _LOW = 341,
     FOR = 342,
     FUNCTION = 343,
     GENERATE = 344,
     GENERIC = 345,
     GUARDED = 346,
     IF = 347,
     IS = 348,
     _NS = 349,
     _PS = 350,
     _FS = 351,
     _MS = 352,
     Identifier = 353,
     _LIBRARY = 354,
     LOOP = 355,
     LeftParen = 356,
     MAP = 357,
     MOD = 358,
     Minus = 359,
     NEW = 360,
     OF = 361,
     ON = 362,
     OPEN = 363,
     OTHERS = 364,
     _PACKAGE = 365,
     PORT = 366,
     PROCEDURE = 367,
     PROCESS = 368,
     Plus = 369,
     _RANGE = 370,
     _REV_RANGE = 371,
     RECORD = 372,
     REGISTER = 373,
     REM = 374,
     REPORT = 375,
     _RETURN = 376,
     RightParen = 377,
     SELECT = 378,
     SEVERITY = 379,
     SIGNAL = 380,
     _STABLE = 381,
     SUBTYPE = 382,
     Semicolon = 383,
     Slash = 384,
     Star = 385,
     StringLit = 386,
     THEN = 387,
     TO = 388,
     TRANSPORT = 389,
     _TYPE = 390,
     UNITS = 391,
     UNTIL = 392,
     USE = 393,
     _VARIABLE = 394,
     VarAsgn = 395,
     WAIT = 396,
     WARNING = 397,
     WHEN = 398,
     WHILE = 399,
     WITH = 400
   };
#endif
/* Tokens.  */
#define _AF 258
#define _AG 259
#define _AX 260
#define _AU 261
#define _EF 262
#define _EG 263
#define _EX 264
#define _EU 265
#define Imply 266
#define Equiv 267
#define tok_AND 268
#define _BEGIN 269
#define _END 270
#define _EQSym 271
#define _EXIT 272
#define _FILE 273
#define _GESym 274
#define _GTSym 275
#define _IN 276
#define _INOUT 277
#define _LABEL 278
#define _LESym 279
#define _LINKAGE 280
#define _LTSym 281
#define _NAND 282
#define _IFT 283
#define _NXOR 284
#define _NESym 285
#define _NEXT 286
#define _NOR 287
#define _NOT 288
#define _OR 289
#define _OUT 290
#define _XOR 291
#define ABS 292
#define ACCESS 293
#define AFTER 294
#define ALIAS 295
#define ALL 296
#define ARCHITECTURE 297
#define ARRAY 298
#define ASSERT 299
#define ATTRIBUTE 300
#define AbstractLit 301
#define Ampersand 302
#define Apostrophe 303
#define Arrow 304
#define BLOCK 305
#define BODY 306
#define BUS 307
#define _BUFFER 308
#define Bar 309
#define BasedInt 310
#define BasedReal 311
#define BitStringLit 312
#define _TRUE 313
#define _FALSE 314
#define Box 315
#define CASE 316
#define COMPONENT 317
#define CONFIGURATION 318
#define _DEFINE 319
#define _ASSUME 320
#define _INITIAL 321
#define _RESET_COND 322
#define CharacterLit 323
#define Colon 324
#define Comma 325
#define DISCONNECT 326
#define DOWNTO 327
#define DecimalInt 328
#define DecimalReal 329
#define Dot 330
#define DoubleStar 331
#define ELSE 332
#define ELSIF 333
#define _ENTITY 334
#define ERROR 335
#define _EVENT 336
#define _LEFT 337
#define _LENGTH 338
#define _RIGHT 339
#define _HIGH 340
#define _LOW 341
#define FOR 342
#define FUNCTION 343
#define GENERATE 344
#define GENERIC 345
#define GUARDED 346
#define IF 347
#define IS 348
#define _NS 349
#define _PS 350
#define _FS 351
#define _MS 352
#define Identifier 353
#define _LIBRARY 354
#define LOOP 355
#define LeftParen 356
#define MAP 357
#define MOD 358
#define Minus 359
#define NEW 360
#define OF 361
#define ON 362
#define OPEN 363
#define OTHERS 364
#define _PACKAGE 365
#define PORT 366
#define PROCEDURE 367
#define PROCESS 368
#define Plus 369
#define _RANGE 370
#define _REV_RANGE 371
#define RECORD 372
#define REGISTER 373
#define REM 374
#define REPORT 375
#define _RETURN 376
#define RightParen 377
#define SELECT 378
#define SEVERITY 379
#define SIGNAL 380
#define _STABLE 381
#define SUBTYPE 382
#define Semicolon 383
#define Slash 384
#define Star 385
#define StringLit 386
#define THEN 387
#define TO 388
#define TRANSPORT 389
#define _TYPE 390
#define UNITS 391
#define UNTIL 392
#define USE 393
#define _VARIABLE 394
#define VarAsgn 395
#define WAIT 396
#define WARNING 397
#define WHEN 398
#define WHILE 399
#define WITH 400




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 62 "./ctp_y.y"

          long          valu;
          char         *text;
          chain_list   *pcha;
          ctp_name      name;
          ctp_vexstr    list;
          ctltype_list  type;
       


/* Line 214 of yacc.c  */
#line 440 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 452 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   376

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  146
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  70
/* YYNRULES -- Number of rules.  */
#define YYNRULES  151
/* YYNRULES -- Number of states.  */
#define YYNSTATES  251

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   400

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    13,    15,    16,    19,    21,
      23,    25,    27,    29,    31,    33,    36,    44,    49,    54,
      59,    62,    69,    71,    77,    79,    81,    84,    90,    94,
      97,    99,   101,   106,   107,   111,   113,   115,   117,   119,
     124,   128,   130,   133,   135,   136,   138,   140,   144,   147,
     149,   153,   155,   157,   159,   161,   162,   165,   167,   170,
     175,   177,   179,   181,   183,   187,   191,   195,   199,   201,
     205,   209,   213,   217,   224,   231,   235,   239,   241,   245,
     247,   249,   252,   256,   258,   260,   262,   264,   266,   268,
     270,   272,   274,   276,   280,   282,   286,   289,   292,   295,
     298,   301,   304,   307,   310,   312,   314,   316,   318,   322,
     324,   326,   328,   330,   332,   334,   336,   338,   340,   342,
     344,   346,   348,   350,   355,   356,   360,   362,   366,   368,
     370,   372,   374,   377,   384,   388,   390,   392,   394,   396,
     398,   400,   402,   404,   406,   407,   411,   412,   416,   418,
     420,   422
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     147,     0,    -1,    -1,   148,   149,    -1,   150,    14,   180,
     215,   214,    -1,   151,    -1,    -1,   151,   152,    -1,   153,
      -1,   158,    -1,   154,    -1,   155,    -1,   156,    -1,   159,
      -1,   162,    -1,     1,   214,    -1,    64,    98,    69,   179,
     174,   157,   214,    -1,    65,    98,   157,   214,    -1,    66,
      98,   157,   214,    -1,    67,    98,   157,   214,    -1,   140,
     184,    -1,   139,   209,    69,   179,   174,   214,    -1,   160,
      -1,   135,    98,    93,   161,   214,    -1,   165,    -1,   169,
      -1,     1,   214,    -1,   127,    98,    93,   163,   214,    -1,
     164,   179,   174,    -1,   179,   174,    -1,   212,    -1,   166,
      -1,   101,   168,   167,   213,    -1,    -1,   167,    70,   168,
      -1,    98,    -1,    68,    -1,   170,    -1,   171,    -1,    43,
     172,   106,   163,    -1,   101,   173,   213,    -1,   177,    -1,
     204,   176,    -1,   179,    -1,    -1,   175,    -1,   176,    -1,
     101,   177,   213,    -1,   115,   177,    -1,   207,    -1,   190,
     178,   190,    -1,   133,    -1,    72,    -1,   212,    -1,   181,
      -1,    -1,   181,   182,    -1,   183,    -1,     1,   214,    -1,
     212,    69,   184,   214,    -1,   185,    -1,   186,    -1,   187,
      -1,   188,    -1,   189,    13,   189,    -1,   185,    13,   189,
      -1,   189,    34,   189,    -1,   186,    34,   189,    -1,   189,
      -1,   189,    27,   189,    -1,   189,    32,   189,    -1,   189,
      29,   189,    -1,   189,    28,   189,    -1,    10,   101,   189,
      70,   189,   213,    -1,     6,   101,   189,    70,   189,   213,
      -1,   189,    36,   189,    -1,   188,    36,   189,    -1,   190,
      -1,   190,   199,   190,    -1,   191,    -1,   195,    -1,   193,
     195,    -1,   191,   192,   195,    -1,   114,    -1,   104,    -1,
      47,    -1,   114,    -1,   104,    -1,   130,    -1,   129,    -1,
     103,    -1,   119,    -1,   196,    -1,   195,   194,   196,    -1,
     197,    -1,   197,    76,   197,    -1,    37,   197,    -1,    33,
     197,    -1,     4,   197,    -1,     3,   197,    -1,     5,   197,
      -1,     7,   197,    -1,     8,   197,    -1,     9,   197,    -1,
     200,    -1,   201,    -1,   204,    -1,   198,    -1,   204,    48,
     201,    -1,    16,    -1,    30,    -1,    19,    -1,    20,    -1,
      24,    -1,    26,    -1,    12,    -1,    11,    -1,    46,    -1,
      68,    -1,   131,    -1,    57,    -1,    58,    -1,    59,    -1,
     101,   203,   202,   213,    -1,    -1,   202,    70,   203,    -1,
     184,    -1,   109,    49,   184,    -1,   212,    -1,   205,    -1,
     206,    -1,   207,    -1,   212,   201,    -1,   212,   101,   190,
     178,   190,   213,    -1,   204,    48,   208,    -1,   126,    -1,
      81,    -1,    82,    -1,    84,    -1,    86,    -1,    85,    -1,
      83,    -1,   115,    -1,   116,    -1,    -1,    98,   210,   211,
      -1,    -1,   211,    70,    98,    -1,    98,    -1,   122,    -1,
     128,    -1,    15,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   275,   275,   275,   316,   326,   329,   331,   336,   337,
     338,   339,   340,   341,   342,   343,   351,   419,   464,   509,
     555,   561,   640,   644,   667,   669,   671,   676,   698,   718,
     738,   744,   750,   807,   809,   816,   820,   827,   834,   839,
     895,   902,   904,   909,   916,   921,   928,   933,   942,   948,
     958,   995,   997,  1004,  1022,  1025,  1027,  1032,  1033,  1039,
    1062,  1064,  1066,  1068,  1073,  1079,  1088,  1094,  1103,  1105,
    1111,  1117,  1123,  1129,  1138,  1150,  1156,  1165,  1167,  1176,
    1181,  1183,  1195,  1204,  1206,  1208,  1212,  1214,  1219,  1221,
    1223,  1225,  1230,  1232,  1241,  1245,  1251,  1256,  1261,  1266,
    1271,  1276,  1281,  1286,  1294,  1304,  1331,  1424,  1440,  1487,
    1489,  1491,  1493,  1495,  1497,  1499,  1501,  1506,  1508,  1511,
    1513,  1515,  1517,  1522,  1538,  1541,  1555,  1564,  1578,  1595,
    1597,  1599,  1604,  1679,  1719,  1798,  1799,  1800,  1801,  1802,
    1803,  1804,  1805,  1806,  1811,  1810,  1815,  1817,  1826,  1831,
    1836,  1841
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "_AF", "_AG", "_AX", "_AU", "_EF", "_EG",
  "_EX", "_EU", "Imply", "Equiv", "tok_AND", "_BEGIN", "_END", "_EQSym",
  "_EXIT", "_FILE", "_GESym", "_GTSym", "_IN", "_INOUT", "_LABEL",
  "_LESym", "_LINKAGE", "_LTSym", "_NAND", "_IFT", "_NXOR", "_NESym",
  "_NEXT", "_NOR", "_NOT", "_OR", "_OUT", "_XOR", "ABS", "ACCESS", "AFTER",
  "ALIAS", "ALL", "ARCHITECTURE", "ARRAY", "ASSERT", "ATTRIBUTE",
  "AbstractLit", "Ampersand", "Apostrophe", "Arrow", "BLOCK", "BODY",
  "BUS", "_BUFFER", "Bar", "BasedInt", "BasedReal", "BitStringLit",
  "_TRUE", "_FALSE", "Box", "CASE", "COMPONENT", "CONFIGURATION",
  "_DEFINE", "_ASSUME", "_INITIAL", "_RESET_COND", "CharacterLit", "Colon",
  "Comma", "DISCONNECT", "DOWNTO", "DecimalInt", "DecimalReal", "Dot",
  "DoubleStar", "ELSE", "ELSIF", "_ENTITY", "ERROR", "_EVENT", "_LEFT",
  "_LENGTH", "_RIGHT", "_HIGH", "_LOW", "FOR", "FUNCTION", "GENERATE",
  "GENERIC", "GUARDED", "IF", "IS", "_NS", "_PS", "_FS", "_MS",
  "Identifier", "_LIBRARY", "LOOP", "LeftParen", "MAP", "MOD", "Minus",
  "NEW", "OF", "ON", "OPEN", "OTHERS", "_PACKAGE", "PORT", "PROCEDURE",
  "PROCESS", "Plus", "_RANGE", "_REV_RANGE", "RECORD", "REGISTER", "REM",
  "REPORT", "_RETURN", "RightParen", "SELECT", "SEVERITY", "SIGNAL",
  "_STABLE", "SUBTYPE", "Semicolon", "Slash", "Star", "StringLit", "THEN",
  "TO", "TRANSPORT", "_TYPE", "UNITS", "UNTIL", "USE", "_VARIABLE",
  "VarAsgn", "WAIT", "WARNING", "WHEN", "WHILE", "WITH", "$accept",
  "ctl_file", "$@1", "ctl_body", "ctl_declarative_part",
  "..block_declarative_item..", "block_declarative_item",
  "constant_declaration", "assumption_declaration", "initial_declaration",
  "reset_cond_declaration", "constant_VarAsgn__expression",
  "variable_declaration", "type_declaration", "full_type_declaration",
  "type_definition", "subtype_declaration", "subtype_indication",
  "type_or_function_name", "scalar_type_definition",
  "enumeration_type_definition", "...enumeration_literal..",
  "enumeration_literal", "composite_type_definition",
  "array_type_definition", "constrained_array_definition",
  "index_constraint", "discrete_range", ".constraint.", "constraint",
  "range_constraint", "range", "direction", "type_mark",
  "ctl_statement_part", "..concurrent_statement..", "concurrent_statement",
  "formula_assignment_statement", "expression",
  "relation..AND__relation..", "relation..OR__relation..",
  "relation.NAND_NOR_NXOR_relation.", "relation..XOR__relation..",
  "relation", "simple_expression", ".sign.term..add_op__term..",
  "adding_operator", "sign", "multiplying_operator", "term", "factor",
  "primary", "qualified_expression", "relational_operator", "literal",
  "aggregate", "...element_association..", "element_association", "name",
  "indexed_name", "slice_name", "attribute_name", "attribute_designator",
  "identifier_list", "$@2", "...identifier..", "simple_name",
  "RightParen_ERR", "Semicolon_ERR", "END_ERR", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   146,   148,   147,   149,   150,   151,   151,   152,   152,
     152,   152,   152,   152,   152,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   161,   161,   162,   163,   163,
     164,   165,   166,   167,   167,   168,   168,   169,   170,   171,
     172,   173,   173,   173,   174,   174,   175,   175,   176,   177,
     177,   178,   178,   179,   180,   181,   181,   182,   182,   183,
     184,   184,   184,   184,   185,   185,   186,   186,   187,   187,
     187,   187,   187,   187,   187,   188,   188,   189,   189,   190,
     191,   191,   191,   192,   192,   192,   193,   193,   194,   194,
     194,   194,   195,   195,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   197,   197,   197,   197,   198,   199,
     199,   199,   199,   199,   199,   199,   199,   200,   200,   200,
     200,   200,   200,   201,   202,   202,   203,   203,   204,   204,
     204,   204,   205,   206,   207,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   210,   209,   211,   211,   212,   213,
     214,   215
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     5,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     7,     4,     4,     4,
       2,     6,     1,     5,     1,     1,     2,     5,     3,     2,
       1,     1,     4,     0,     3,     1,     1,     1,     1,     4,
       3,     1,     2,     1,     0,     1,     1,     3,     2,     1,
       3,     1,     1,     1,     1,     0,     2,     1,     2,     4,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     3,
       3,     3,     3,     6,     6,     3,     3,     1,     3,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     0,     3,     1,     3,     1,     1,
       1,     1,     2,     6,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     6,     1,     3,     0,     0,    55,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     8,    10,    11,
      12,     9,    13,    22,    14,     0,     0,   150,    15,     0,
       0,     0,     0,     0,     0,   144,     0,   151,     0,     0,
     148,    56,    57,     0,     0,     0,     0,     0,     0,     0,
       0,   146,     0,     4,    58,     0,    44,    53,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,   120,
     121,   122,   118,     0,    87,    86,   119,    20,    60,    61,
      62,    63,    68,    77,    79,     0,    80,    92,    94,   107,
     104,   105,   106,   129,   130,   131,   128,    17,    18,    19,
       0,     0,    44,    53,     0,     0,     0,     0,    24,    31,
      25,    37,    38,   145,    44,     0,     0,     0,     0,    45,
      46,    99,    98,   100,     0,   101,   102,   103,     0,    97,
      96,     0,   126,   124,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   116,   115,   109,   111,   112,   113,
     114,   110,     0,    85,    84,    83,     0,    81,    90,    91,
      89,    88,     0,     0,     0,     0,   132,    27,    44,    29,
      26,     0,     0,    36,    35,    33,    23,     0,     0,    59,
       0,     0,   131,    48,     0,     0,     0,     0,     0,    65,
      67,    76,    64,    69,    72,    71,    70,    66,    75,    78,
      82,    93,    95,   136,   137,   141,   138,   140,   139,   142,
     143,   135,   108,   134,    77,    28,     0,    41,    43,   106,
     128,     0,     0,   147,    21,   149,    47,    52,    51,     0,
      16,     0,     0,   127,     0,   123,     0,    40,    42,    39,
       0,    32,    50,     0,     0,   125,     0,    34,    74,    73,
     133
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     4,     5,     6,    16,    17,    18,    19,
      20,    46,    21,    22,    23,   107,    24,   100,   101,   108,
     109,   222,   175,   110,   111,   112,   172,   216,   118,   119,
     120,   180,   229,   102,    25,    26,    41,    42,   132,    78,
      79,    80,    81,    82,    83,    84,   156,    85,   162,    86,
      87,    88,    89,   152,    90,    91,   188,   133,    92,    93,
      94,    95,   213,    36,    51,   113,    96,   226,    28,    38
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -99
static const yytype_int16 yypact[] =
{
     -99,    21,   -99,   -99,   -99,    14,    15,   -99,   -98,   -57,
     -43,   -42,   -38,   -34,   -33,   -30,   -99,   -99,   -99,   -99,
     -99,   -99,   -99,   -99,   -99,    44,     2,   -99,   -99,    -8,
     -71,   -71,   -71,   -22,    -7,   -99,    20,   -99,   -98,   -98,
     -99,   -99,   -99,    22,    -3,   118,   -98,   -98,   -98,    -3,
       7,   -99,    -3,   -99,   -99,   118,   -49,   -99,   110,   110,
     110,     3,   110,   110,   110,    10,   110,   110,   -99,   -99,
     -99,   -99,   -99,    39,   -99,   -99,   -99,   -99,   100,    81,
     -99,    82,   231,   287,   -20,   196,    62,   -99,    43,   -99,
     -99,   -99,    96,   -99,   -99,   -99,    37,   -99,   -99,   -99,
     -98,    -3,   -49,    51,   -98,    59,   -44,   -98,   -99,   -99,
     -99,   -99,   -99,    91,   -49,   -98,   126,   126,   -71,   -99,
     -99,   -99,   -99,   -99,   126,   -99,   -99,   -99,   126,   -99,
     -99,   103,   -99,   -99,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -99,   126,   -99,   -99,   -99,   196,    62,   -99,   -99,
     -99,   -99,   196,   110,   207,    39,   -99,   -99,   -49,   -99,
     -99,   126,    60,   -99,   -99,   -99,   -99,    73,   -98,   -99,
      52,   -60,   -23,   -99,   -98,   112,   117,   118,   -45,   -99,
     -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
      62,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -99,   -99,   -99,    90,   -99,    52,   -99,   -99,   -28,
     -48,    -3,   -19,   -99,   -99,   -99,   -99,   -99,   -99,   126,
     -99,   126,   126,   -99,    39,   -99,   126,   -99,   -99,   -99,
     -44,   -99,   -99,    52,    52,   -99,    52,   -99,   -99,   -99,
     -99
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -25,   -99,   -99,   -99,   -99,   -99,   -32,   -99,   -99,
     -99,   -99,   -67,   -99,   -99,   -99,   -99,   -99,   -80,   -99,
     -31,   -79,   -24,   -39,   -99,   -99,   -99,   -99,   -41,   -99,
     -99,   -99,   -99,   144,    41,   -99,   -99,   -99,   -99,   -66,
      18,   -27,   -99,   -99,   -99,   -81,   -99,   -36,    25,   -99,
     -99,   -59,   -99,   -99,   -99,   -99,   -26,    -9,   -37,   -99
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -55
static const yytype_int16 yytable[] =
{
      43,    53,    54,    39,    77,    56,    47,    48,   104,    97,
      98,    99,   227,   114,   115,   166,     8,   -54,    57,   157,
     164,     3,   169,   103,   173,   234,    57,   153,     7,    -5,
      27,   121,   122,   123,   178,   125,   126,   127,   183,   129,
     130,    29,    58,    59,    60,    61,    62,    63,    64,    65,
     105,   240,   116,   165,   174,    30,    31,   182,   182,    37,
      32,    44,   168,   167,    33,    34,   117,   170,    35,    45,
     176,    49,    66,   228,   -53,    57,    67,   225,   179,     9,
      10,    11,    12,   212,   154,    68,    50,   117,   215,    52,
     200,    55,   217,   184,   155,    40,    69,    70,    71,   -49,
      40,   144,   145,   225,   124,   -49,   146,    72,   106,   147,
     148,   128,   182,   134,   149,   135,   150,   -49,   136,   163,
     151,    58,    59,    60,    61,    62,    63,    64,    65,    58,
      59,    60,   218,    62,    63,    64,   202,    40,   165,   166,
      73,   224,    13,    74,   164,   220,   233,   230,   131,   -30,
      14,    66,   187,    75,    15,    67,    68,   181,   181,    66,
     171,   177,   227,    67,    68,   158,   221,    69,    70,    71,
      76,   223,    68,   247,   225,    69,    70,    71,    72,   235,
     201,   159,   231,    69,    70,    71,    72,   232,   238,   239,
     236,   160,   161,   199,    72,   103,   219,     0,   245,    58,
      59,    60,     0,    62,    63,    64,   214,   237,    40,     0,
       0,    73,   181,   241,     0,     0,    40,     0,     0,    73,
       0,     0,    74,   228,    40,     0,     0,    73,     0,    66,
      74,     0,    75,    67,   248,   249,     0,   250,     0,     0,
      75,    76,    68,     0,   137,     0,     0,     0,     0,    76,
       0,     0,     0,    69,    70,    71,     0,    76,   138,   139,
     140,     0,     0,   141,    72,   142,     0,   143,   185,     0,
     242,     0,   186,     0,     0,     0,     0,   246,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   203,   204,
     205,   206,   207,   208,    40,     0,     0,    73,   144,   145,
       0,     0,     0,   146,     0,     0,   147,   148,    73,     0,
       0,   149,     0,   150,     0,     0,     0,   151,     0,     0,
       0,     0,   209,   210,     0,     0,     0,    76,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   243,   244
};

static const yytype_int16 yycheck[] =
{
      26,    38,    39,     1,    45,    44,    31,    32,     1,    46,
      47,    48,    72,    52,    55,    96,     1,    15,    44,    85,
      48,     0,   102,    49,    68,    70,    52,    47,    14,    14,
     128,    58,    59,    60,   114,    62,    63,    64,   117,    66,
      67,    98,     3,     4,     5,     6,     7,     8,     9,    10,
      43,    70,   101,   101,    98,    98,    98,   116,   117,    15,
      98,    69,   101,   100,    98,    98,   115,   104,    98,   140,
     107,    93,    33,   133,   122,   101,    37,   122,   115,    64,
      65,    66,    67,   164,   104,    46,    93,   115,   168,    69,
     156,    69,   171,   118,   114,    98,    57,    58,    59,   122,
      98,    11,    12,   122,   101,   128,    16,    68,   101,    19,
      20,   101,   171,    13,    24,    34,    26,   140,    36,    76,
      30,     3,     4,     5,     6,     7,     8,     9,    10,     3,
       4,     5,   171,     7,     8,     9,   163,    98,   101,   220,
     101,   178,   127,   104,    48,   171,   187,   184,   109,    98,
     135,    33,    49,   114,   139,    37,    46,   116,   117,    33,
     101,    70,    72,    37,    46,   103,   106,    57,    58,    59,
     131,    98,    46,   240,   122,    57,    58,    59,    68,   188,
     162,   119,    70,    57,    58,    59,    68,    70,   219,   221,
     214,   129,   130,   152,    68,   221,   171,    -1,   234,     3,
       4,     5,    -1,     7,     8,     9,   165,   216,    98,    -1,
      -1,   101,   171,   222,    -1,    -1,    98,    -1,    -1,   101,
      -1,    -1,   104,   133,    98,    -1,    -1,   101,    -1,    33,
     104,    -1,   114,    37,   243,   244,    -1,   246,    -1,    -1,
     114,   131,    46,    -1,    13,    -1,    -1,    -1,    -1,   131,
      -1,    -1,    -1,    57,    58,    59,    -1,   131,    27,    28,
      29,    -1,    -1,    32,    68,    34,    -1,    36,   124,    -1,
     229,    -1,   128,    -1,    -1,    -1,    -1,   236,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,    81,    82,
      83,    84,    85,    86,    98,    -1,    -1,   101,    11,    12,
      -1,    -1,    -1,    16,    -1,    -1,    19,    20,   101,    -1,
      -1,    24,    -1,    26,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,   115,   116,    -1,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   231,   232
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   147,   148,     0,   149,   150,   151,    14,     1,    64,
      65,    66,    67,   127,   135,   139,   152,   153,   154,   155,
     156,   158,   159,   160,   162,   180,   181,   128,   214,    98,
      98,    98,    98,    98,    98,    98,   209,    15,   215,     1,
      98,   182,   183,   212,    69,   140,   157,   157,   157,    93,
      93,   210,    69,   214,   214,    69,   179,   212,     3,     4,
       5,     6,     7,     8,     9,    10,    33,    37,    46,    57,
      58,    59,    68,   101,   104,   114,   131,   184,   185,   186,
     187,   188,   189,   190,   191,   193,   195,   196,   197,   198,
     200,   201,   204,   205,   206,   207,   212,   214,   214,   214,
     163,   164,   179,   212,     1,    43,   101,   161,   165,   166,
     169,   170,   171,   211,   179,   184,   101,   115,   174,   175,
     176,   197,   197,   197,   101,   197,   197,   197,   101,   197,
     197,   109,   184,   203,    13,    34,    36,    13,    27,    28,
      29,    32,    34,    36,    11,    12,    16,    19,    20,    24,
      26,    30,   199,    47,   104,   114,   192,   195,   103,   119,
     129,   130,   194,    76,    48,   101,   201,   214,   179,   174,
     214,   101,   172,    68,    98,   168,   214,    70,   174,   214,
     177,   190,   207,   177,   157,   189,   189,    49,   202,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   190,
     195,   196,   197,    81,    82,    83,    84,    85,    86,   115,
     116,   126,   201,   208,   190,   174,   173,   177,   179,   204,
     212,   106,   167,    98,   214,   122,   213,    72,   133,   178,
     214,    70,    70,   184,    70,   213,   178,   213,   176,   163,
      70,   213,   190,   189,   189,   203,   190,   168,   213,   213,
     213
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 275 "./ctp_y.y"
    {
            ctltype_list *CtlType;

            CTP_HEADFIG = addctlfig( CTP_FILENAME );;
            CTP_MODNAM  = CTP_HEADFIG->NAME;
            addctlpredefinedtype( CTP_HEADFIG );

            hshtab = initab ();

            CTP_NM1LST = NULL;
            CTP_INSLST = NULL;
            CTP_LINLST = NULL;
            CTP_VALLST = NULL;

            CTP_ERRFLG    = 0;
            CTP_LINNUM    = 1;
            CTP_NUMTYP    = 0;

            CtlType = CTP_HEADFIG->TYPE;

            while( CtlType )
            {
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_LBLDFN,CtlType->CLASS);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_TYPDFN,CtlType->INDEX);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_WMNDFN,CtlType->LEFT);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_WMXDFN,CtlType->RIGHT);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_PNTDFN,(long)CtlType);

              CtlType = CtlType->NEXT;
            }

            CTP_NUMTYP = VEX_MAX_TYPE;
          }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 310 "./ctp_y.y"
    {
            fretab( hshtab );
          }
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 321 "./ctp_y.y"
    {
         }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 345 "./ctp_y.y"
    {
           my_ctp_error(9,NULL);
         }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 358 "./ctp_y.y"
    {
          ctltype_list  *Type;
          ctldecl_list  *CtlCst;
          vexexpr       *VexValue;
          chain_list    *HeadChain;
          chain_list    *ScanChain;
          ctp_vexstr    *VexStr;
          short          Signed;
          long           Left;
          long           Right;
          short          Width;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[(6) - (7)].list).VEX );

          Type = val_type( (yyvsp[(4) - (7)].name).NAME );

          if ( ( (yyvsp[(5) - (7)].name).LEFT  == -1 ) &&
               ( (yyvsp[(5) - (7)].name).RIGHT == -1 ) )
          {
            AttrLeft  = Type->LEFT;
            AttrRight = Type->RIGHT;
          }
          else
          {
            AttrLeft  = (yyvsp[(5) - (7)].name).LEFT;
            AttrRight = (yyvsp[(5) - (7)].name).RIGHT;
          }

          CtlCst  = (ctldecl_list *)ctp_addstr( 'C',0,val_type((yyvsp[(4) - (7)].name).NAME),
                 (yyvsp[(4) - (7)].name).TYPE,(yyvsp[(4) - (7)].name).FLAG,(yyvsp[(2) - (7)].text),AttrLeft,AttrRight,VexValue);

          Signed = ( IsVexNodeSigned( CtlCst->VEX_ATOM ) != 0 );

          {
            if ( IsVexAtomBit( CtlCst->VEX_ATOM ) )
            {
              Left  = -1;
              Right = -1;
            }
            else
            {
              Left  = CtlCst->VEX_ATOM->LEFT;
              Right = CtlCst->VEX_ATOM->RIGHT;
            }
          }

          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_TYPDFN,(yyvsp[(4) - (7)].name).TYPE);
          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlCst->VEX_ATOM);
          addtab(hshtab,(yyvsp[(2) - (7)].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 423 "./ctp_y.y"
    {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          chain_list    *HeadChain;
          chain_list    *ScanChain;
          ctp_vexstr    *VexStr;
          short          Signed;
          long           Left;
          long           Right;
          short          Width;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[(3) - (4)].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'A',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[(2) - (4)].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 468 "./ctp_y.y"
    {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          chain_list    *HeadChain;
          chain_list    *ScanChain;
          ctp_vexstr    *VexStr;
          short          Signed;
          long           Left;
          long           Right;
          short          Width;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[(3) - (4)].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'I',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[(2) - (4)].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 513 "./ctp_y.y"
    {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          chain_list    *HeadChain;
          chain_list    *ScanChain;
          ctp_vexstr    *VexStr;
          short          Signed;
          long           Left;
          long           Right;
          short          Width;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[(3) - (4)].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'R',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[(2) - (4)].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[(2) - (4)].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 557 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 567 "./ctp_y.y"
    {
            char         *LocalName;
            char         *signame;
            char         *codedsigname;
            char          buffer[ 128 ];
            ctltype_list *Type;
            ctldecl_list *CtlVar;
            short         Signed;
            long          Left;
            long          Right;
            long          AttrLeft;
            long          AttrRight;
            char          StrFlag;
            vexexpr      *VexInit;
            struct ctp_expr expr1;

            LocalName = CTP_MODNAM;
            Type  = val_type( (yyvsp[(4) - (6)].name).NAME );

            if ( ( (yyvsp[(5) - (6)].name).LEFT  == -1 ) &&
                 ( (yyvsp[(5) - (6)].name).RIGHT == -1 ) )
            {
              AttrLeft  = Type->LEFT;
              AttrRight = Type->RIGHT;
            }
            else
            {
              AttrLeft  = (yyvsp[(5) - (6)].name).LEFT;
              AttrRight = (yyvsp[(5) - (6)].name).RIGHT;
            }

            CTP_NM1LST = reverse (CTP_NM1LST);

            while (CTP_NM1LST != NULL)
            {
              signame = (char *)CTP_NM1LST->DATA;
              if (chktab (hshtab,signame,LocalName,CTP_SYMDFN) != 0)
                  my_ctp_error (80,signame);

              CtlVar = (ctldecl_list *)ctp_addstr( 'V', 0,
                      val_type((yyvsp[(4) - (6)].name).NAME),(yyvsp[(4) - (6)].name).TYPE,
                      (yyvsp[(4) - (6)].name).FLAG,signame, AttrLeft, AttrRight, NULL );

              Signed = ( IsVexNodeSigned( CtlVar->VEX_ATOM ) != 0 );

              if ( IsVexAtomBit( CtlVar->VEX_ATOM ) )
              {
                Left  = -1;
                Right = -1;
              }
              else
              {
                Left  = CtlVar->VEX_ATOM->LEFT;
                Right = CtlVar->VEX_ATOM->RIGHT;
              }

              addtab (hshtab,signame,LocalName,CTP_SYMDFN,CTP_VARDFN);
              addtab (hshtab,signame,LocalName,CTP_TYPDFN,(yyvsp[(4) - (6)].name).TYPE);
              addtab (hshtab,signame,LocalName,CTP_WMNDFN,Left);
              addtab (hshtab,signame,LocalName,CTP_WMXDFN,Right);
              addtab (hshtab,signame,LocalName,CTP_ATLDFN,AttrLeft);
              addtab (hshtab,signame,LocalName,CTP_ATRDFN,AttrRight);
              addtab (hshtab,signame,LocalName,CTP_LBLDFN,0);
              addtab (hshtab,signame,LocalName,CTP_PNTDFN,(long)CtlVar->VEX_ATOM);
              addtab (hshtab,signame,LocalName,CTP_SUNDFN,Signed);

              CTP_NM1LST = delchain (CTP_NM1LST,CTP_NM1LST);
            }
          }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 649 "./ctp_y.y"
    {
           ctltype_list *CtlType;

           CtlType = addctltype( CTP_HEADFIG,(yyvsp[(2) - (5)].text), CTP_NUMTYP, (yyvsp[(4) - (5)].type).LEFT,
               (yyvsp[(4) - (5)].type).RIGHT,(yyvsp[(4) - (5)].type).SIZE,(yyvsp[(4) - (5)].type).VALUE, (yyvsp[(4) - (5)].type).CLASS, (yyvsp[(4) - (5)].type).BASE );
           addctlline( CTP_HEADFIG, &CtlType->LINE, CTP_LINNUM);

           addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
           addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_LBLDFN,(yyvsp[(4) - (5)].type).CLASS);
           addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_TYPDFN,CTP_NUMTYP);
           addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_WMNDFN,(yyvsp[(4) - (5)].type).LEFT);
           addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_WMXDFN,(yyvsp[(4) - (5)].type).RIGHT);
           addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlType );
           CTP_NUMTYP++;
         }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 668 "./ctp_y.y"
    { (yyval.type) = (yyvsp[(1) - (1)].type); }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 670 "./ctp_y.y"
    { (yyval.type) = (yyvsp[(1) - (1)].type); }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 672 "./ctp_y.y"
    { yyerrok; }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 681 "./ctp_y.y"
    {
            ctltype_list *CtlType;

            CtlType = addctltype(CTP_HEADFIG,(yyvsp[(2) - (5)].text),(yyvsp[(4) - (5)].type).INDEX,(yyvsp[(4) - (5)].type).LEFT,
                   (yyvsp[(4) - (5)].type).RIGHT, (yyvsp[(4) - (5)].type).SIZE, (yyvsp[(4) - (5)].type).VALUE, (yyvsp[(4) - (5)].type).CLASS,(yyvsp[(4) - (5)].type).BASE );
            addctlline( CTP_HEADFIG, &CtlType->LINE, CTP_LINNUM);
            addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
            addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_LBLDFN,(yyvsp[(4) - (5)].type).CLASS);
            addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_TYPDFN,(yyvsp[(4) - (5)].type).INDEX);
            addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_WMNDFN,(yyvsp[(4) - (5)].type).LEFT);
            addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_WMXDFN,(yyvsp[(4) - (5)].type).RIGHT);
            addtab(hshtab,(yyvsp[(2) - (5)].text),CTP_MODNAM,CTP_PNTDFN,(long)CTP_HEADFIG->TYPE);
            CTP_NUMTYP++;
          }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 701 "./ctp_y.y"
    {
           ctltype_list *ctltype_pnt;
           long          mode;
  
           mode = chktab(hshtab,(yyvsp[(1) - (3)].text),CTP_MODNAM,CTP_SYMDFN);

           ctltype_pnt = (ctltype_list *)chktab(hshtab,(yyvsp[(2) - (3)].name).NAME,CTP_MODNAM,CTP_PNTDFN);
  
           (yyval.type).NAME = NULL;
           (yyval.type).BASE = ctltype_pnt;
           (yyval.type).VALUE = NULL ;
           (yyval.type).SIZE = 0 ;
           (yyval.type).INDEX = CTP_NUMTYP;
           (yyval.type).LEFT  = (yyvsp[(3) - (3)].name).LEFT ;
           (yyval.type).RIGHT = (yyvsp[(3) - (3)].name).RIGHT ;
           (yyval.type).CLASS = (yyvsp[(3) - (3)].name).FLAG ;
         }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 720 "./ctp_y.y"
    {
           ctltype_list *ctltype_pnt;
  
           ctltype_pnt = (ctltype_list *)chktab(hshtab,(yyvsp[(1) - (2)].name).NAME,CTP_MODNAM,CTP_PNTDFN);
  
           (yyval.type).NAME = NULL;
           (yyval.type).BASE = ctltype_pnt;
           (yyval.type).VALUE = NULL ;
           (yyval.type).SIZE = 0 ;
           (yyval.type).INDEX = CTP_NUMTYP;
           (yyval.type).CLASS = (yyvsp[(2) - (2)].name).FLAG;

           (yyval.type).LEFT    = (yyvsp[(2) - (2)].name).LEFT ;
           (yyval.type).RIGHT   = (yyvsp[(2) - (2)].name).RIGHT ;
        }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 739 "./ctp_y.y"
    { (yyval.text) = (yyvsp[(1) - (1)].text); }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 745 "./ctp_y.y"
    {
            (yyval.type) = (yyvsp[(1) - (1)].type);
          }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 754 "./ctp_y.y"
    {
              char *enumname;
              char *enumval;
              long  size;
              long  indice;
              long  numbit;
              char **pnt;
              chain_list *nm1lst;

              CTP_NM1LST = reverse (CTP_NM1LST);

              nm1lst = CTP_NM1LST;
              size   = 0;

              while (nm1lst != NULL)
              {
                size++;
                nm1lst = nm1lst->NEXT;
              }

              pnt = (char **) autallocblock(size * sizeof(char*));

              indice = 0;

              while (CTP_NM1LST != NULL)
              {
                enumname = (char *)CTP_NM1LST->DATA;

                if (chktab (hshtab,enumname,CTP_MODNAM,CTP_SYMDFN) != 0)
                  my_ctp_error (82,enumname);

                addtab (hshtab,enumname,CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_TYPDFN,CTP_NUMTYP);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_WMNDFN,-1);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_WMXDFN,-1);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_LBLDFN,indice);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_PNTDFN,(long)pnt);
                
                pnt[indice++] = enumname;
                CTP_NM1LST = delchain (CTP_NM1LST, CTP_NM1LST);
              }

              (yyval.type).VALUE = pnt ;
              (yyval.type).SIZE = size ;
              (yyval.type).LEFT = -1 ;
              (yyval.type).RIGHT = -1 ;
              (yyval.type).INDEX = CTP_NUMTYP;
              (yyval.type).CLASS = 'E' ;
              (yyval.type).BASE = 0 ;
        }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 812 "./ctp_y.y"
    { yyerrok; }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 817 "./ctp_y.y"
    {
            CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[(1) - (1)].text));
          }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 821 "./ctp_y.y"
    {
            CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[(1) - (1)].text));
          }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 828 "./ctp_y.y"
    {
            (yyval.type) = (yyvsp[(1) - (1)].type);
          }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 835 "./ctp_y.y"
    { (yyval.type) = (yyvsp[(1) - (1)].type); }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 843 "./ctp_y.y"
    {
            ctltype_list *NewType;
            char       *name;
            char        buffer[ 32 ];

            (yyval.type) = (yyvsp[(4) - (4)].type);

            if ( (yyvsp[(4) - (4)].type).CLASS == 'U' )
            {
              if ( (yyvsp[(4) - (4)].type).BASE->CLASS != 'A' )
              {
                my_ctp_error(123,NULL);
              }
            }
            else
            if ( (yyvsp[(4) - (4)].type).CLASS == 'A' )
            {
              if ( (yyvsp[(4) - (4)].type).BASE->CLASS != 'U' )
              {
                my_ctp_error(123,NULL);
              }

              sprintf( buffer, "_subtype_%d", CTP_NUMTYP );
              name = namealloc( buffer );

              NewType = addctltype(CTP_HEADFIG,name,(yyvsp[(4) - (4)].type).INDEX, (yyvsp[(4) - (4)].type).LEFT,
                   (yyvsp[(4) - (4)].type).RIGHT,(yyvsp[(4) - (4)].type).SIZE,(yyvsp[(4) - (4)].type).VALUE,(yyvsp[(4) - (4)].type).CLASS,(yyvsp[(4) - (4)].type).BASE );
              addctlline( CTP_HEADFIG, &NewType->LINE, CTP_LINNUM);
              addtab(hshtab,name,CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
              addtab(hshtab,name,CTP_MODNAM,CTP_LBLDFN,(yyvsp[(4) - (4)].type).CLASS);
              addtab(hshtab,name,CTP_MODNAM,CTP_TYPDFN,(yyvsp[(4) - (4)].type).INDEX);
              addtab(hshtab,name,CTP_MODNAM,CTP_WMNDFN,(yyvsp[(4) - (4)].type).LEFT);
              addtab(hshtab,name,CTP_MODNAM,CTP_WMXDFN,(yyvsp[(4) - (4)].type).RIGHT);
              addtab(hshtab,name,CTP_MODNAM,CTP_PNTDFN,(long)CTP_HEADFIG->TYPE );
              CTP_NUMTYP++;

              (yyval.type).BASE = NewType;
            }
            else
            {
              my_ctp_error(123,NULL);
            }

            (yyval.type).CLASS = 'A';
            (yyval.type).INDEX = (yyvsp[(2) - (4)].name).TYPE;

            (yyval.type).LEFT  = (yyvsp[(2) - (4)].name).LEFT;
            (yyval.type).RIGHT = (yyvsp[(2) - (4)].name).RIGHT;
          }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 898 "./ctp_y.y"
    { (yyval.name) = (yyvsp[(2) - (3)].name);}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 903 "./ctp_y.y"
    { (yyval.name) = (yyvsp[(1) - (1)].name);}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 906 "./ctp_y.y"
    { (yyval.name) = (yyvsp[(2) - (2)].name);
           (yyval.name).NAME = (yyvsp[(1) - (2)].name).NAME;
         }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 911 "./ctp_y.y"
    { (yyval.name) = (yyvsp[(1) - (1)].name);}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 916 "./ctp_y.y"
    {
          (yyval.name).FLAG   = 'U';
          (yyval.name).LEFT   = -1;
          (yyval.name).RIGHT  = -1;
        }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 922 "./ctp_y.y"
    { 
          (yyval.name) = (yyvsp[(1) - (1)].name);
        }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 929 "./ctp_y.y"
    { 
           (yyval.name) = (yyvsp[(1) - (1)].name);
         }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 936 "./ctp_y.y"
    {
           (yyval.name) = (yyvsp[(2) - (3)].name);
         }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 944 "./ctp_y.y"
    { (yyval.name) = (yyvsp[(2) - (2)].name); }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 949 "./ctp_y.y"
    {
           if ( ( (yyvsp[(1) - (1)].name).FLAG != CTP_RANGE     ) &&
                ( (yyvsp[(1) - (1)].name).FLAG != CTP_REV_RANGE ) )
           {
             my_ctp_error (32,NULL);
           }

           (yyval.name) = (yyvsp[(1) - (1)].name);
         }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 961 "./ctp_y.y"
    {
           long Left;
           long Right;
           long ErrorL;
           long  ErrorR;

           ErrorL = ctp_vextonum( (yyvsp[(1) - (3)].list).VEX, &Left  );
           ErrorR = ctp_vextonum( (yyvsp[(3) - (3)].list).VEX, &Right );

           (yyval.name).NAME   = NULL;
           (yyval.name).TYPE   = (yyvsp[(1) - (3)].list).TYPE;
           (yyval.name).SIGNED = 0;
           (yyval.name).FLAG   = 'A';

           if ( ( ! ErrorL ) && ( ! ErrorR ) )
           {
             if (((Left > Right) && ((yyvsp[(2) - (3)].valu) == CTP_UPTDFN)) ||
                  ((Left < Right) && ((yyvsp[(2) - (3)].valu) == CTP_DWTDFN)))
             {
               my_ctp_error (32,NULL);
             }

             (yyval.name).LEFT   = Left;
             (yyval.name).RIGHT  = Right;
           }
           else
           {
             (yyval.name).LEFT    = (long)(yyvsp[(1) - (3)].list).VEX;
             (yyval.name).RIGHT   = (long)(yyvsp[(3) - (3)].list).VEX;
           }
         }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 996 "./ctp_y.y"
    { (yyval.valu) = CTP_UPTDFN; }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 998 "./ctp_y.y"
    { (yyval.valu) = CTP_DWTDFN; }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 1005 "./ctp_y.y"
    {
              long type;
              (yyval.name).NAME = (yyvsp[(1) - (1)].text);
              (yyval.name).LEFT = -1;
              (yyval.name).RIGHT = -1;
              (yyval.name).TYPE = chktab(hshtab,(yyvsp[(1) - (1)].text),CTP_MODNAM,CTP_TYPDFN);
              (yyval.name).FLAG = chktab(hshtab,(yyvsp[(1) - (1)].text),CTP_MODNAM,CTP_LBLDFN);
              type = chktab(hshtab,(yyvsp[(1) - (1)].text),CTP_MODNAM,CTP_SYMDFN);

              if (type != CTP_TPEDFN || (yyval.name).TYPE ==0)
              {
                my_ctp_error(84,(yyvsp[(1) - (1)].text));
              }
          }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 1035 "./ctp_y.y"
    { my_ctp_error (18,NULL); }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 1043 "./ctp_y.y"
    {
           ctlform_list *CtlForm;
           vexexpr      *VexForm;

           VexForm = simpvexexpr( (yyvsp[(3) - (4)].list).VEX );

           if (chktab (hshtab,(yyvsp[(1) - (4)].text), CTP_MODNAM,CTP_SYMDFN) != 0)
           {
             my_ctp_error (80,(yyvsp[(1) - (4)].text));
           }

           CtlForm = addctlform( CTP_HEADFIG, (yyvsp[(1) - (4)].text), VexForm );
           addctlline( CTP_HEADFIG, &CtlForm->LINE, CTP_LINNUM);

           addtab(hshtab,(yyvsp[(1) - (4)].text),CTP_MODNAM,CTP_SYMDFN,CTP_LABDFN);
         }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 1063 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1065 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 1067 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1069 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1076 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_AND ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1082 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_AND ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1091 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_OR ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1097 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_OR ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1104 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1108 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_NAND ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1114 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_NOR ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1120 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_NXOR ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1126 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_IFT,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1135 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_EU,(yyvsp[(3) - (6)].list) ,(yyvsp[(5) - (6)].list) ,-1,-1);
         }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1144 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex (VEX_AU,(yyvsp[(3) - (6)].list) ,(yyvsp[(5) - (6)].list) ,-1,-1);
         }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1153 "./ctp_y.y"
    {
           (yyval.list) = ctp_crtvex (VEX_XOR ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1159 "./ctp_y.y"
    {
           (yyval.list) = ctp_crtvex (VEX_XOR ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1166 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1170 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex ((yyvsp[(2) - (3)].valu) ,(yyvsp[(1) - (3)].list) ,(yyvsp[(3) - (3)].list) ,-1,-1);
         }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1177 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1182 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1185 "./ctp_y.y"
    {
             if ( (yyvsp[(1) - (2)].valu) == VEX_NEG )
             {
               (yyval.list) = ctp_crtvex( VEX_NEG,(yyvsp[(2) - (2)].list),NULL,-1,-1);
             }
             else
             {
               (yyval.list) = (yyvsp[(2) - (2)].list);
             }
          }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1198 "./ctp_y.y"
    {
            (yyval.list) = ctp_crtvex((yyvsp[(2) - (3)].valu),(yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list),-1,-1);
          }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1205 "./ctp_y.y"
    { (yyval.valu) = VEX_ADD; }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1207 "./ctp_y.y"
    { (yyval.valu) = VEX_SUB; }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1209 "./ctp_y.y"
    { (yyval.valu) = VEX_CONCAT; }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1213 "./ctp_y.y"
    { (yyval.valu) = 0; }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1215 "./ctp_y.y"
    { (yyval.valu) = VEX_NEG; }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1220 "./ctp_y.y"
    { (yyval.valu) = VEX_MUL; }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1222 "./ctp_y.y"
    { (yyval.valu) = VEX_DIV; }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1224 "./ctp_y.y"
    { (yyval.valu) = VEX_MOD; }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1226 "./ctp_y.y"
    { (yyval.valu) = VEX_REM; }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1231 "./ctp_y.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1235 "./ctp_y.y"
    {
           (yyval.list) = ctp_crtvex( (yyvsp[(2) - (3)].valu), (yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list),-1,-1);
         }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1242 "./ctp_y.y"
    {
           (yyval.list) = (yyvsp[(1) - (1)].list);
         }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1248 "./ctp_y.y"
    {
           (yyval.list) = ctp_crtvex( VEX_EXP,(yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list),-1,-1);
         }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1253 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex( VEX_ABS,(yyvsp[(2) - (2)].list),CTP_EMPSTR,-1,-1); 
         }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1258 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex( VEX_NOT,(yyvsp[(2) - (2)].list),CTP_EMPSTR,-1,-1);
         }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1263 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex( VEX_AG,(yyvsp[(2) - (2)].list),CTP_EMPSTR,-1,-1);
         }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1268 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex( VEX_AF,(yyvsp[(2) - (2)].list),CTP_EMPSTR,-1,-1);
         }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1273 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex( VEX_AX,(yyvsp[(2) - (2)].list),CTP_EMPSTR,-1,-1);
         }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1278 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex( VEX_EF,(yyvsp[(2) - (2)].list),CTP_EMPSTR,-1,-1);
         }
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1283 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex( VEX_EG,(yyvsp[(2) - (2)].list),CTP_EMPSTR,-1,-1);
         }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1288 "./ctp_y.y"
    { 
           (yyval.list) = ctp_crtvex( VEX_EX,(yyvsp[(2) - (2)].list),CTP_EMPSTR,-1,-1);
         }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1295 "./ctp_y.y"
    {
           struct ctp_expr expr1;

           expr1.IDENT = (yyvsp[(1) - (1)].text);
           expr1.TYPE  = -1;
           expr1.VEX   = (vexexpr *)0;

           (yyval.list) = ctp_crtvex( NOPS,expr1,CTP_EMPSTR,-1,-1);
        }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1305 "./ctp_y.y"
    {
            ctp_vexstr *VexStr;
            chain_list *ScanChain;

            ScanChain = (yyvsp[(1) - (1)].pcha);

            if ( ScanChain == (chain_list *)0 )
            {
              my_ctp_error(114,NULL);
            }

            if ( ScanChain->NEXT == (chain_list *)0 )
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;

              (yyval.list) = *VexStr;

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );
              freechain( ScanChain );
            }
            else
            {
              (yyval.list).IDENT  = (char *)(yyvsp[(1) - (1)].pcha);
              (yyval.list).AGGREG = 1;
            }
        }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1332 "./ctp_y.y"
    {
          struct ctp_expr expr1;
          char           *LocalName;
          char            Buffer[ 40 ];
          long            left;
          long            right;
          long            left_bnd;
          long            right_bnd;
          long            in_bound;
          long            out_bound;
          long             mode;
          long             flag;

          flag = (yyvsp[(1) - (1)].name).FLAG;

          if ( ( flag != 0          ) &&
               ( flag != CTP_EVENT  ) &&
               ( flag != CTP_STABLE ) )
          {
            if ( ( flag != CTP_RANGE     ) &&
                 ( flag != CTP_REV_RANGE ) )
            {
              {
                sprintf( Buffer, "%ld", (yyvsp[(1) - (1)].name).LEFT );

                expr1.IDENT = Buffer;
                expr1.VEX   = (vexexpr *)0;
                expr1.TYPE  = -1;

                (yyval.list) = ctp_crtvex( NOPS, expr1, CTP_EMPSTR, -1, -1);
              }
            }
            else
            {
              autexit( 1 );
            }
          }
          else
          if ( ( (yyvsp[(1) - (1)].name).NAME[0] == '"' ) ||
               ( (yyvsp[(1) - (1)].name).NAME[0] == '\'') )
          {
            expr1.IDENT = (yyvsp[(1) - (1)].name).NAME;
            expr1.VEX   = (vexexpr *)0;
            expr1.TYPE  = -1;

            (yyval.list) = ctp_crtvex( NOPS ,expr1, CTP_EMPSTR, -1, -1); /* as for literal */
          }
          else
          {
            LocalName = CTP_MODNAM;
            mode = chktab (hshtab,(yyvsp[(1) - (1)].name).NAME,LocalName,CTP_SYMDFN);

            if( mode == 0 )
            {
              my_ctp_error (17,(yyvsp[(1) - (1)].name).NAME);
            }

            left_bnd  = chktab (hshtab,(yyvsp[(1) - (1)].name).NAME,LocalName,CTP_WMNDFN);
            right_bnd = chktab (hshtab,(yyvsp[(1) - (1)].name).NAME,LocalName,CTP_WMXDFN);
              
            left  = (yyvsp[(1) - (1)].name).LEFT;
            right = (yyvsp[(1) - (1)].name).RIGHT;

            {
              long  type;

              expr1.IDENT = (yyvsp[(1) - (1)].name).NAME;
              type = chktab(hshtab,(yyvsp[(1) - (1)].name).NAME,LocalName,CTP_TYPDFN);
              expr1.TYPE = type;
              expr1.SIGNED = chktab (hshtab,(yyvsp[(1) - (1)].name).NAME,LocalName,CTP_SUNDFN);

              {
                expr1 = ctp_crtvex (NOPI,expr1,CTP_EMPSTR,left,right);
              }

              if( flag == CTP_EVENT )
              {
                (yyval.list) = ctp_crtvex (VEX_EVENT,expr1,CTP_EMPSTR,left,right);
              }
              else
              if( flag == CTP_STABLE )
              {
                expr1 = ctp_crtvex(VEX_EVENT,expr1,CTP_EMPSTR,left,right);
                (yyval.list)    = ctp_crtvex (VEX_NOT,expr1,CTP_EMPSTR,-1,-1);
              }
              else
              {
                (yyval.list) = expr1;
              }
            }
          }
        }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1425 "./ctp_y.y"
    {
          struct ctp_expr expr1;

          expr1.IDENT  = (yyvsp[(1) - (1)].name).NAME;
          expr1.TYPE   = (yyvsp[(1) - (1)].name).TYPE;
          expr1.SIGNED = (yyvsp[(1) - (1)].name).SIGNED;
          expr1.VEX    = (vexexpr *)(yyvsp[(1) - (1)].name).LEFT;

          expr1 = ctp_crtvex(SUBVAR,expr1,CTP_EMPSTR,expr1.VEX->LEFT,expr1.VEX->RIGHT);

          (yyval.list) = expr1;
        }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1443 "./ctp_y.y"
    {
            char       *LocalName;
            ctp_vexstr *VexStr;
            chain_list *ScanChain;
            vexexpr    *VexExpr;
            long        Def;

            ScanChain = (yyvsp[(3) - (3)].pcha);

            if ( ( ScanChain       == (chain_list *)0 ) ||
                 ( ScanChain->NEXT != (chain_list *)0 ) )
            {
              my_ctp_error(122,NULL);
            }

            LocalName = CTP_MODNAM;
            Def = chktab (hshtab,(yyvsp[(1) - (3)].name).NAME,LocalName,CTP_SYMDFN);

            if ( Def == CTP_TPEDFN )
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;

              VexExpr = createvexfunc( (yyvsp[(1) - (3)].name).NAME, VexStr->VEX->WIDTH );
              addvexhexpr( VexExpr, VexStr->VEX );

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              (yyval.name).NAME    = (yyvsp[(1) - (3)].name).NAME;
              (yyval.name).TYPE    = chktab (hshtab,(yyvsp[(1) - (3)].name).NAME,LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED  = chktab (hshtab,(yyvsp[(1) - (3)].name).NAME,LocalName,CTP_SUNDFN);
              (yyval.name).FLAG    = 0;
              (yyval.name).LEFT    = (long)VexExpr;
              (yyval.name).RIGHT   = 0;

              freechain( (yyvsp[(3) - (3)].pcha) );
            }
            else
            {
              my_ctp_error(122, (yyvsp[(1) - (3)].name).NAME);
            }
          }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1488 "./ctp_y.y"
    { (yyval.valu) = VEX_EQ; }
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1490 "./ctp_y.y"
    { (yyval.valu) = VEX_NE; }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1492 "./ctp_y.y"
    { (yyval.valu) = VEX_GE; }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1494 "./ctp_y.y"
    { (yyval.valu) = VEX_GT; }
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1496 "./ctp_y.y"
    { (yyval.valu) = VEX_LE; }
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1498 "./ctp_y.y"
    { (yyval.valu) = VEX_LT; }
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1500 "./ctp_y.y"
    { (yyval.valu) = VEX_EQUIV; }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1502 "./ctp_y.y"
    { (yyval.valu) = VEX_IMPLY; }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1507 "./ctp_y.y"
    { (yyval.text) = (yyvsp[(1) - (1)].text); }
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1509 "./ctp_y.y"
    { 
                (yyval.text) = (yyvsp[(1) - (1)].text); }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1512 "./ctp_y.y"
    { (yyval.text) = (yyvsp[(1) - (1)].text); }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1514 "./ctp_y.y"
    { (yyval.text) = (yyvsp[(1) - (1)].text); }
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1516 "./ctp_y.y"
    { (yyval.text) = namealloc( "'1'" ); }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1518 "./ctp_y.y"
    { (yyval.text) = namealloc( "'0'" ); }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1526 "./ctp_y.y"
    {
            if ( (yyvsp[(3) - (4)].pcha) != (chain_list *)0 )
            {
              (yyvsp[(2) - (4)].pcha)->NEXT = reverse( (yyvsp[(3) - (4)].pcha) );
            }

            (yyval.pcha) = (yyvsp[(2) - (4)].pcha);
          }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1538 "./ctp_y.y"
    { 
            (yyval.pcha) = (chain_list *)0;
          }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1544 "./ctp_y.y"
    {
            if ( (yyvsp[(1) - (3)].pcha) != (chain_list *)0 )
            {
              (yyvsp[(3) - (3)].pcha)->NEXT = (yyvsp[(1) - (3)].pcha);
            }

            (yyval.pcha) = (yyvsp[(3) - (3)].pcha);
          }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1556 "./ctp_y.y"
    { 
            ctp_vexstr *VexStr;

            VexStr  = (ctp_vexstr *)autallocheap( sizeof( ctp_vexstr ) );
            *VexStr = (yyvsp[(1) - (1)].list);

            (yyval.pcha) = addchain( (chain_list *)0, VexStr );
          }
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1567 "./ctp_y.y"
    {
            ctp_vexstr *VexStr;

            VexStr  = (ctp_vexstr *)autallocheap( sizeof( ctp_vexstr ) );
            *VexStr = ctp_crtvex( VEX_OTHERS, (yyvsp[(3) - (3)].list),CTP_EMPSTR,-1,-1);

            (yyval.pcha) = addchain( (chain_list *)0, VexStr );
          }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1579 "./ctp_y.y"
    {
           authelem *valbitstr;
           char     *codedsigname;
           char     *LocalName;
           char      buffer[128];

           LocalName = CTP_MODNAM;

           (yyval.name).NAME = (yyvsp[(1) - (1)].text);
           (yyval.name).FLAG = 0;

           (yyval.name).TYPE   = chktab (hshtab,(yyvsp[(1) - (1)].text),LocalName,CTP_TYPDFN);
           (yyval.name).LEFT   = chktab (hshtab,(yyvsp[(1) - (1)].text),LocalName,CTP_WMNDFN);
           (yyval.name).RIGHT  = chktab (hshtab,(yyvsp[(1) - (1)].text),LocalName,CTP_WMXDFN);
           (yyval.name).SIGNED = chktab (hshtab,(yyvsp[(1) - (1)].text),LocalName,CTP_SUNDFN);
         }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1596 "./ctp_y.y"
    { (yyval.name) = (yyvsp[(1) - (1)].name); }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1598 "./ctp_y.y"
    { (yyval.name) = (yyvsp[(1) - (1)].name); }
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1600 "./ctp_y.y"
    { (yyval.name) = (yyvsp[(1) - (1)].name); }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1606 "./ctp_y.y"
    {
            char       *LocalName;
            ctp_vexstr *VexStr;
            chain_list *ScanChain;
            vexexpr    *VexExpr;
            vexexpr    *VexRet;
            long        Index;
            long         Error;
            long        Def;

            ScanChain = (yyvsp[(2) - (2)].pcha);

            if ( ScanChain == (chain_list *)0 )
            {
              my_ctp_error(114,NULL);
            }

            LocalName = CTP_MODNAM;
            Def = chktab (hshtab,(yyvsp[(1) - (2)].text),LocalName,CTP_SYMDFN);

            if ( ScanChain->NEXT != (chain_list *)0 )
            {
              if ( ( ! Def                                    ) || 
                   ( ScanChain->NEXT->NEXT != (chain_list *)0 ) )
              {
                my_ctp_error(118,(yyvsp[(1) - (2)].text));
              }

              /* ICI */

              (yyval.name).NAME   = (yyvsp[(1) - (2)].text);
              (yyval.name).TYPE   = chktab (hshtab,(yyvsp[(1) - (2)].text),LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED = chktab (hshtab,(yyvsp[(1) - (2)].text),LocalName,CTP_SUNDFN);
              (yyval.name).FLAG   = 0;

              VexStr  = (ctp_vexstr *)ScanChain->DATA;
              (yyval.name).LEFT = (long)VexStr->VEX;
              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              ScanChain = ScanChain->NEXT;
              VexStr   = (ctp_vexstr *)ScanChain->DATA;
              (yyval.name).RIGHT = (long)VexStr->VEX;
              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              freechain( (yyvsp[(2) - (2)].pcha) );
            }
            else
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;
              Error  = ctp_vextonum( VexStr->VEX, &Index );

              (yyval.name).NAME   = (yyvsp[(1) - (2)].text);
              (yyval.name).TYPE   = chktab (hshtab,(yyvsp[(1) - (2)].text),LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED = chktab (hshtab,(yyvsp[(1) - (2)].text),LocalName,CTP_SUNDFN);
              (yyval.name).FLAG   = 0;

              if ( Error )
              {
                my_ctp_error(36, (yyvsp[(1) - (2)].text));
              }
              else
              {
                (yyval.name).LEFT   = Index;
                (yyval.name).RIGHT  = Index;
              }

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );
              freechain( ScanChain );
            }
          }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1685 "./ctp_y.y"
    {
           char *LocalName;
           long  Left;
           long  Right;
           long   ErrorL;
           long   ErrorR;

           LocalName = CTP_MODNAM;

           ErrorL = ctp_vextonum( (yyvsp[(3) - (6)].list).VEX, &Left  );
           ErrorR = ctp_vextonum( (yyvsp[(5) - (6)].list).VEX, &Right );

           (yyval.name).NAME   = (yyvsp[(1) - (6)].text);
           (yyval.name).TYPE   = chktab (hshtab,(yyvsp[(1) - (6)].text),LocalName,CTP_TYPDFN);
           (yyval.name).SIGNED = chktab (hshtab,(yyvsp[(1) - (6)].text),LocalName,CTP_SUNDFN);
           (yyval.name).FLAG   = 0;

           if ( ( ! ErrorL ) && ( ! ErrorR ) )
           {
             if (((Left > Right) && ((yyvsp[(4) - (6)].valu) == CTP_UPTDFN)) ||
                  ((Left < Right) && ((yyvsp[(4) - (6)].valu) == CTP_DWTDFN)))
               my_ctp_error (32,(yyvsp[(1) - (6)].text));

             (yyval.name).LEFT   = Left;
             (yyval.name).RIGHT  = Right;
           }
           else
           {
             my_ctp_error (36,(yyvsp[(1) - (6)].text));
           }
         }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1722 "./ctp_y.y"
    {
            char *LocalName;
            long   type;
            long   flag;
            long   mode;
            long  AttrLeft;
            long  AttrRight;
            long  AttrLow;
            long  AttrHigh;

            LocalName = CTP_MODNAM;
            mode = chktab (hshtab,(yyvsp[(1) - (3)].name).NAME,LocalName,CTP_SYMDFN);
            type = chktab (hshtab,(yyvsp[(1) - (3)].name).NAME,LocalName,CTP_TYPDFN);
            flag = (yyvsp[(3) - (3)].valu);

            (yyval.name).NAME   = (yyvsp[(1) - (3)].name).NAME;
            (yyval.name).TYPE   = type;
            (yyval.name).LEFT   = -1;
            (yyval.name).RIGHT  = -1;
            (yyval.name).SIGNED = chktab (hshtab,(yyvsp[(1) - (3)].name).NAME,LocalName,CTP_SUNDFN);
            (yyval.name).FLAG   = (yyvsp[(3) - (3)].valu);

            if ( ( flag == CTP_STABLE ) ||
                 ( flag == CTP_EVENT  ) )
            {
              if ( LocalName != CTP_MODNAM )
                my_ctp_error (79,(yyvsp[(1) - (3)].name));
            }
            else
            {
              AttrLeft  = chktab( hshtab,(yyvsp[(1) - (3)].name).NAME,LocalName,CTP_ATLDFN);
              AttrRight = chktab( hshtab,(yyvsp[(1) - (3)].name).NAME,LocalName,CTP_ATRDFN);

              {
                if ( AttrLeft > AttrRight )
                {
                  AttrLow  = AttrRight;
                  AttrHigh = AttrLeft;
                }
                else
                {
                  AttrHigh = AttrRight;
                  AttrLow  = AttrLeft;
                }
              }

              switch ( flag )
              {
                case CTP_LEFT   : (yyval.name).LEFT = AttrLeft;
                break;

                case CTP_RIGHT  : (yyval.name).LEFT = AttrRight;
                break;

                case CTP_LOW    : (yyval.name).LEFT = AttrLow;
                break;

                case CTP_HIGH   : (yyval.name).LEFT = AttrHigh;
                break;

                case CTP_LENGTH : (yyval.name).LEFT = 1 + (AttrHigh - AttrLow);
                break;

                case CTP_RANGE  : (yyval.name).LEFT  = AttrLeft;
                                  (yyval.name).RIGHT = AttrRight;
                break;

                case CTP_REV_RANGE : (yyval.name).LEFT  = AttrRight;
                                     (yyval.name).RIGHT = AttrLeft;
                break;
              }
            }
          }
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1798 "./ctp_y.y"
    { (yyval.valu) = CTP_STABLE; }
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1799 "./ctp_y.y"
    { (yyval.valu) = CTP_EVENT; }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1800 "./ctp_y.y"
    { (yyval.valu) = CTP_LEFT; }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1801 "./ctp_y.y"
    { (yyval.valu) = CTP_RIGHT; }
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1802 "./ctp_y.y"
    { (yyval.valu) = CTP_LOW; }
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1803 "./ctp_y.y"
    { (yyval.valu) = CTP_HIGH; }
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1804 "./ctp_y.y"
    { (yyval.valu) = CTP_LENGTH; }
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1805 "./ctp_y.y"
    { (yyval.valu) = CTP_RANGE; }
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1806 "./ctp_y.y"
    { (yyval.valu) = CTP_REV_RANGE; }
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1811 "./ctp_y.y"
    { CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[(1) - (1)].text)); }
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1820 "./ctp_y.y"
    { 
                  CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[(3) - (3)].text));
                }
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1827 "./ctp_y.y"
    { (yyval.text) = (yyvsp[(1) - (1)].text); }
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1832 "./ctp_y.y"
    { yyerrok; }
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1837 "./ctp_y.y"
    { yyerrok; }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1842 "./ctp_y.y"
    { yyerrok; }
    break;



/* Line 1455 of yacc.c  */
#line 3854 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1845 "./ctp_y.y"


static struct dct_entry *addent (head , key)
struct dct_entry *head;
char             *key;

{
  struct dct_entry *entry = NULL;
  long              i;

  if (CTP_DCEHED == NULL)
    {
    CTP_DCEHED = (struct dct_entry *)
                 autallocblock (sizeof(struct dct_entry) * CTP_ALODFN);

    entry = CTP_DCEHED;
    for (i=1 ; i<CTP_ALODFN ; i++)
      {
      entry->next = entry + 1;
      entry++;
      }
    entry->next = NULL;
    }

  entry       = CTP_DCEHED;
  CTP_DCEHED  = CTP_DCEHED->next;

  entry->next = head;
  entry->data = NULL;
  entry->key  = key;

  return (entry);
}

static struct dct_recrd *addrcd (head , key)

struct dct_recrd *head;
char             *key;

{
  struct dct_recrd *recrd = NULL;
  long               i;

  if (CTP_DCRHED == NULL)
    {
    CTP_DCRHED = (struct dct_recrd *)
                 autallocblock (sizeof(struct dct_recrd) * CTP_ALODFN);

    recrd = CTP_DCRHED;
    for (i=1 ; i<CTP_ALODFN ; i++)
      {
      recrd->next = recrd + 1;
      recrd++;
      }
    recrd->next = NULL;
    }

  recrd           = CTP_DCRHED;
  CTP_DCRHED      = CTP_DCRHED->next;

  recrd->next     = head;
  recrd->key      = key;

  return (recrd);
}

static struct dct_entry **initab ()

{
  struct dct_entry **head = NULL;
  long                i;

  head = (struct dct_entry **)
         autallocblock (sizeof(struct dct_entry *) * CTP_HSZDFN);

  for (i=0 ; i<CTP_HSZDFN ; i++)
    head[i] = NULL;

  return (head);
}

static void addtab (head,key_str,ctx_str,field,valu)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
long               field;
long               valu;

{
  long              found = 0;
  long              index;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  index     = ((unsigned long) key_str) % CTP_HSZDFN;
  entry_pnt = head[index];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 0)
    {
    head[index] = addent (head[index],key_str);
    entry_pnt = head[index];
    }

  found = 0;
  recrd_pnt = entry_pnt->data;
  while (recrd_pnt != NULL)
    {
    if (recrd_pnt->key == ctx_str)
      {
      found = 1;
      break;
      }
    recrd_pnt = recrd_pnt->next;
    }

  if (found == 0)
    {
    entry_pnt->data = addrcd (entry_pnt->data,ctx_str);
    recrd_pnt       = entry_pnt->data ;
    }

  switch (field)
    {
      case CTP_MODDFN :
        recrd_pnt->fd0_val = valu;
        break;
      case CTP_SYMDFN :
        recrd_pnt->fd1_val = valu;
        break;
      case CTP_TYPDFN :
        recrd_pnt->fd2_val = valu;
        break;
      case CTP_SUNDFN :
        recrd_pnt->fd3_val = valu;
        break;
      case CTP_LBLDFN :
        recrd_pnt->fd4_val = valu;
        break;
      case CTP_WMXDFN :
        recrd_pnt->fd5_val = valu;
        break;
      case CTP_WMNDFN :
        recrd_pnt->fd6_val = valu;
        break;
      case CTP_ATLDFN :
        recrd_pnt->fd7_val = valu;
        break;
      case CTP_ATRDFN :
        recrd_pnt->fd8_val = valu;
        break;
      case CTP_PNTDFN :
        recrd_pnt->pnt_val = valu;
        break;
    }
}

static long chktab (head,key_str,ctx_str,field)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
long               field;

{
  long              found = 0;
  long              valu = 0;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  entry_pnt = head [((unsigned long)key_str) % CTP_HSZDFN];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 1)
    {
    found = 0;
    recrd_pnt = entry_pnt->data;
    while (recrd_pnt != NULL)
      {
      if (recrd_pnt->key == ctx_str)
        {
        found = 1;
        break;
        }
      recrd_pnt = recrd_pnt->next;
      }
    if (found == 1)
      {
      switch (field)
        {
        case CTP_MODDFN :
          valu = recrd_pnt->fd0_val;
          break;
        case CTP_SYMDFN :
          valu = recrd_pnt->fd1_val;
          break;
        case CTP_TYPDFN :
          valu = recrd_pnt->fd2_val;
          break;
        case CTP_SUNDFN :
          valu = recrd_pnt->fd3_val;
          break;
        case CTP_LBLDFN :
          valu = recrd_pnt->fd4_val;
          break;
        case CTP_WMXDFN :
          valu = recrd_pnt->fd5_val;
          break;
        case CTP_WMNDFN :
          valu = recrd_pnt->fd6_val;
          break;
        case CTP_ATLDFN :
          valu = recrd_pnt->fd7_val;
          break;
        case CTP_ATRDFN :
          valu = recrd_pnt->fd8_val;
          break;
        case CTP_PNTDFN :
          valu = recrd_pnt->pnt_val;
          break;
        }
      }
    }

  return (valu);
}

static void fretab (pt_hash)

struct dct_entry **pt_hash;
{
  struct dct_entry *pt_entry;
  struct dct_entry *pt_nxtentry;
  struct dct_recrd *pt_record;
  long              i;

  if (pt_hash != NULL)
    {
    for (i=0 ; i<CTP_HSZDFN ; i++)
      {
      if ((pt_entry = pt_hash[i]) != NULL)
        {
        while (pt_entry != NULL)
          {
          pt_record = pt_entry->data;

          while (pt_record->next != NULL)
            pt_record = pt_record->next;

          pt_record->next = CTP_DCRHED;
          CTP_DCRHED      = pt_entry->data;

          pt_nxtentry     = pt_entry->next;
          pt_entry->next  = CTP_DCEHED;
          CTP_DCEHED      = pt_entry;
          pt_entry        = pt_nxtentry;
          }
        }
      }
    autfreeblock(pt_hash);
    }
}

static void *ctp_addstr(object,mode,prtype,type,flag,name,left,right,exp)

char          object;
long           mode;
ctltype_list *prtype;
unsigned char type;
char          flag;
char         *name;
long          left;
long          right;
vexexpr      *exp;

{ 
  ctlform_list *CtlForm;
  ctldecl_list *CtlDeclar;
  void         *pnt    = NULL;
  vexexpr      *vex_pnt;
  long           bitsize;

  if ( object == 'F' )
  {
    CtlForm = addctlform( CTP_HEADFIG, name, exp );
    addctlline( CTP_HEADFIG, &CtlForm->LINE, CTP_LINNUM );

    return( (void *)CtlForm );
  }


  if ( (flag == 'A') ||
       (flag == 'U') )
  {
       /* ###------------------------------------------------------### */
       /*   if object is an array ...                                   */
       /* ###------------------------------------------------------### */

    if ( flag == 'A' )
    {
      vex_pnt = createvexatomvec( name, prtype->LEFT, prtype->RIGHT ); 
    }
    else
    {
      vex_pnt = createvexatomvec( name, left, right );
    }

    if ( prtype->INDEX == VEX_TYPE_SIGNED )
    {
      SetVexNodeSigned( vex_pnt );
    }

  }
  else
  if ( (flag == 'I') )
  {
       /* ###------------------------------------------------------### */
       /*   if object is an integer ...                            */
       /* ###------------------------------------------------------### */

      if ((left == -1 ) && (right == -1))
      {
        left  = prtype->LEFT;
        right = prtype->RIGHT;
      }

      bitsize = ctp_intSize( left, right );

      vex_pnt = createvexatomvec( name, bitsize - 1, 0 );

      if ( ( left  < 0 ) ||
           ( right < 0 ) )
      {
        SetVexNodeSigned( vex_pnt );
      }
  }
  else
  {
       /* ###------------------------------------------------------### */
       /*   if object is a scalar ...                                   */
       /* ###------------------------------------------------------### */
    vex_pnt = createvexatombit( name );
  }

  if ( object == 'C' )
  {
    CtlDeclar = addctldecldef( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'V' )
  {
    CtlDeclar = addctldeclvar( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'A' )
  {
    CtlDeclar = addctldeclass( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'I' )
  {
    CtlDeclar = addctldeclinit( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'R' )
  {
    CtlDeclar = addctldeclreset( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }

  return (pnt);
}

static ctltype_list *val_type(name)

 char *name;
{
  return( searchctltype( CTP_HEADFIG, name ) );
}

static ctltype_list *get_type(val)

  long val;
{
  ctltype_list *Type;

  for ( Type  = CTP_HEADFIG->TYPE;
        Type != (ctltype_list *)0;
        Type  = Type->NEXT )
  {
    if  ( Type->INDEX == val ) break;
  }

  return( Type );
}

int ctp_y_wrap ()
{
  return (1);
}


